prg_start   = $1201
prg_sysaddr = $120d

    .zeropage

s:
sl: .res 1
sh: .res 1
d:
dl: .res 1
dh: .res 1
c:
cl: .res 1
ch: .res 1

    .code

main:   jmp start

blk5:   .incbin "blk5.bin"
blk5_end:
prg:    .incbin "prg.bin"
prg_end:

prg_size    = prg_end - prg
blk5_size   = blk5_end - blk5

.proc start
    ; Copy PRG to where it should be.
    lda #<prg
    sta sl
    lda #>prg
    sta sh
    lda #<prg_start
    sta dl
    lda #>prg_start
    sta dh
    lda #0
    sta cl
    ldx #1 + <prg_size
    lda #1 + >prg_size
    sta ch
    jsr copy

    ; Copy data to BLK5.
    lda #$00
    sta sl
    sta cl
    lda #$a0
    sta sh
    lda #<blk5
    sta dl
    lda #>blk5
    sta dh
    ldx #1 + <blk5_size
    lda #1 + >blk5_size
    sta ch
    jsr copy

    ; Start the PRG.
    jmp prg_sysaddr

copy:
    ldy #0
    beq n ; (jmp)
l:  lda (s),y
    sta (d),y
    iny
    beq +m
n:  dex
    bne l
    dec ch
    bne l
    rts
m:  inc sh
    inc dh
    bne n ; (jmp)
.endproc
